diff --git a/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index eaac8dd84..d42b85a25 100644
--- a/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -159,7 +159,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
             }
             if (movedId != 0) {
                 BlockTileEntity.createNewEntityOnPlace = false;
-                Block.blocksList[movedId].onBlockPlacedByWorld(worldObj, x, y, z);
+                Blocks.blocksList[movedId].onBlockPlacedByWorld(worldObj, x, y, z);
                 BlockTileEntity.createNewEntityOnPlace = true;
             }
             assert movedEntity == null || worldObj.getBlockEntity(x, y, z) == movedEntity : "Piston failed to actually move entity!";
diff --git a/src/main/java/net/minecraft/core/data/DataLoader.java b/game/core/src/main/java/net/minecraft/core/data/DataLoader.java
similarity index 99%
rename from src/main/java/net/minecraft/core/data/DataLoader.java
rename to game/core/src/main/java/net/minecraft/core/data/DataLoader.java
index a634f9547..342dd06a4 100644
--- a/src/main/java/net/minecraft/core/data/DataLoader.java
+++ b/game/core/src/main/java/net/minecraft/core/data/DataLoader.java
@@ -14,7 +14,7 @@ import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.adapter.*;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.RecipeSyncPacket;
+import net.minecraft.core.net.packet.PacketRecipeSync;
 import org.slf4j.Logger;
 
 import java.io.*;
@@ -204,7 +204,7 @@ public class DataLoader {
         LOGGER.info("Registered {} recipes",i);
     }
 
-    public static void loadRecipeFromServer(RecipeSyncPacket packet){
+    public static void loadRecipeFromServer(PacketRecipeSync packet){
         JsonArray jsonArray = JsonParser.parseString(packet.recipe).getAsJsonArray();
         GsonBuilder builder = new GsonBuilder();
         builder.setPrettyPrinting();
diff --git a/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
similarity index 99%
rename from src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
rename to game/core/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
index e6be04422..e795341fe 100644
--- a/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
@@ -8,6 +8,7 @@ import java.util.Set;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.BlockLog;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -37,7 +38,7 @@ public class TreecapitatorHelper {
 	
 	public boolean chopTree() {
 		int id = world.getBlockId(basePosition.x, basePosition.y, basePosition.z);
-		if(!isLog(Block.getBlock(id))) {
+		if(!isLog(Blocks.getBlock(id))) {
 			return false;
 		}
 		
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
similarity index 96%
rename from src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
rename to game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 9319c04ae..d30aad4c1 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -8,7 +8,7 @@ import com.google.gson.JsonParseException;
 import com.google.gson.JsonSerializationContext;
 import com.google.gson.JsonSerializer;
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.HardIllegalArgumentException;
@@ -29,13 +29,12 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
     @Override
     public ItemStack deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
         JsonObject obj = json.getAsJsonObject();
-        ItemStack stack;
         Item item;
         if (obj.has("key")) {
             String key = obj.get("key").getAsString();
             try {
                 if (key.startsWith("tile.")){
-                    item = Item.itemsList[Block.keyToIdMap.get(key)];
+                    item = Item.itemsList[Blocks.keyToIdMap.get(key)];
                 } else if (key.startsWith("item.")){
                     item = Item.itemsList[Item.nameToIdMap.get(key)];
                 } else {
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
similarity index 98%
rename from src/main/java/net/minecraft/core/entity/Entity.java
rename to game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 2f436b111..8f5c71d20 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -4,6 +4,7 @@ import java.util.List;
 import java.util.Random;
 
 import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.ICarriable;
@@ -631,12 +632,14 @@ public abstract class Entity
             
             this.isWalking = walkDistO != walkDist;
             
-            int walkedSteps = (int) (walkDist - nextStep);
-            if(walkedSteps > 0 && blockWalkedOn != null) {
-            	nextStep += walkedSteps;
-                if (!muteStepSounds) {
-                	world.playBlockSoundEffect(this, this.x, this.bb.minY, this.z, blockWalkedOn, EnumBlockSoundEffectType.STEP);
-                	blockWalkedOn.onEntityWalking(world, blockX, blockY, blockZ, this);
+            if (canInteract()) {
+                int walkedSteps = (int) (walkDist - nextStep);
+                if(walkedSteps > 0 && blockWalkedOn != null) {
+                    nextStep += walkedSteps;
+                    if (!muteStepSounds) {
+                        world.playBlockSoundEffect(this, this.x, this.bb.minY, this.z, blockWalkedOn, EnumBlockSoundEffectType.STEP);
+                        blockWalkedOn.onEntityWalking(world, blockX, blockY, blockZ, this);
+                    }
                 }
             }
         }
@@ -657,7 +660,7 @@ public abstract class Entity
                         int blockId = world.getBlockId(_x, _y, _z);
                         if(blockId > 0)
                         {
-                            Block.blocksList[blockId].onEntityCollidedWithBlock(world, _x, _y, _z, this);
+                            Blocks.blocksList[blockId].onEntityCollidedWithBlock(world, _x, _y, _z, this);
                         }
                     }
 
@@ -703,6 +706,10 @@ public abstract class Entity
         }
     }
 
+    public boolean canInteract() {
+        return true;
+    }
+
     protected boolean makeStepSound()
     {
         return true;
@@ -773,7 +780,7 @@ public abstract class Entity
         int j = MathHelper.floor_float(MathHelper.floor(d));
         int k = MathHelper.floor(z);
         int l = world.getBlockId(i, j, k);
-        if(l != 0 && Block.blocksList[l].blockMaterial == material)
+        if(l != 0 && Blocks.blocksList[l].blockMaterial == material)
         {
             float f = BlockFluid.getWaterVolume(world.getBlockMetadata(i, j, k)) - 0.2F;
             float f1 = (float)(j + 1) - f;
diff --git a/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
similarity index 98%
rename from src/main/java/net/minecraft/core/entity/EntityItem.java
rename to game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index a48f94408..218c8ead2 100644
--- a/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -119,7 +119,7 @@ public class EntityItem extends Entity
             int blockId = world.getBlockId(MathHelper.floor(x), MathHelper.floor(bb.minY) - 1, MathHelper.floor(z));
             if(blockId > 0)
             {
-                friction = Block.blocksList[blockId].friction * 0.98F;
+                friction = Blocks.blocksList[blockId].friction * 0.98F;
             }
         }
         xd *= friction;
@@ -201,7 +201,7 @@ public class EntityItem extends Entity
 
 			if(item.stackSize < previousStackSize) {
 				if(item.itemID < 16384) {
-					if(Block.blocksList[item.itemID] instanceof BlockLog) {
+					if(Blocks.blocksList[item.itemID] instanceof BlockLog) {
 						player.triggerAchievement(Achievements.MINE_WOOD);
 					}
 				}
diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
similarity index 97%
rename from src/main/java/net/minecraft/core/entity/Mob.java
rename to game/core/src/main/java/net/minecraft/core/entity/Mob.java
index eee37609e..b23d62aab 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -170,6 +170,13 @@ public abstract class Mob extends Entity
         return variantList.getSkinReference(basePath + "variants.json", "0", getSkinVariant());
     }
 
+    public boolean cycleVariant() {
+        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
+        int skinVar = getSkinVariant();
+        setSkinVariant(Global.accessor.getSkinVariantList().nextSkinVariant(basePath + "variants.json", skinVar));
+        return skinVar != getSkinVariant();
+    }
+
     public int getSkinVariant() {
         return Byte.toUnsignedInt(entityData.getByte(DATA_VARIANT));
     }
@@ -692,7 +699,7 @@ public abstract class Mob extends Entity
             int j = world.getBlockId(MathHelper.floor(x), MathHelper.floor(y - 0.2D - (double) heightOffset), MathHelper.floor(z));
             if(j > 0)
             {
-                world.playBlockSoundEffect(this, this.x, this.y - this.heightOffset, this.z, Block.blocksList[j], EnumBlockSoundEffectType.ENTITY_LAND);
+                world.playBlockSoundEffect(this, this.x, this.y - this.heightOffset, this.z, Blocks.blocksList[j], EnumBlockSoundEffectType.ENTITY_LAND);
             }
         }
     }
@@ -763,8 +770,7 @@ public abstract class Mob extends Entity
             Block b = world.getBlock(blockX, blockY, blockZ);
             float depth = 0.6f;
             if (b != null) {
-                b.setBlockBoundsBasedOnState(world, blockX, blockY, blockZ);
-                depth = 1 - (float) b.maxY;
+                depth = 1 - (float) b.getBlockBoundsFromState(world, blockX, blockY, blockZ).maxY;
             }
             if(horizontalCollision && isFree(xd, ((yd + depth + 0.2) - y) + d, zd))
             {
@@ -785,7 +791,7 @@ public abstract class Mob extends Entity
                 yd = 0.3D;
             }
         }
-        else if (canSkate() && Block.blocksList[floorBlockId] != null && Block.blocksList[floorBlockId].hasTag(BlockTags.SKATEABLE))
+        else if (canSkate() && Blocks.blocksList[floorBlockId] != null && Blocks.blocksList[floorBlockId].hasTag(BlockTags.SKATEABLE))
         {
             muteStepSounds = true;
             isSkating = true;
@@ -829,7 +835,7 @@ public abstract class Mob extends Entity
                 movementScale = 0.5460001F;
                 if(floorBlockId > 0)
                 {
-                    movementScale = Block.blocksList[floorBlockId].friction * 0.91F;
+                    movementScale = Blocks.blocksList[floorBlockId].friction * 0.91F;
                 }
             }
 
@@ -841,7 +847,7 @@ public abstract class Mob extends Entity
                 movementScale = 0.5460001F;
                 if(floorBlockId > 0)
                 {
-                    movementScale = Block.blocksList[floorBlockId].friction * 0.91F;
+                    movementScale = Blocks.blocksList[floorBlockId].friction * 0.91F;
                 }
 
             }
@@ -1248,7 +1254,7 @@ public abstract class Mob extends Entity
         Vec3 head = getPosition(partialTick, true);
         Vec3 viewDirection = getViewVector(partialTick);
         Vec3 furthestPoint = head.add(viewDirection.x * distance, viewDirection.y * distance, viewDirection.z * distance);
-        return world.checkBlockCollisionBetweenPoints(head, furthestPoint, collideWithFluids, ignoreNonColliderBlocks);
+        return world.checkBlockCollisionBetweenPoints(head, furthestPoint, collideWithFluids, ignoreNonColliderBlocks, false);
     }
 
     public int getMaxSpawnedInChunk()
diff --git a/src/main/java/net/minecraft/core/entity/MobFlying.java b/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
similarity index 92%
rename from src/main/java/net/minecraft/core/entity/MobFlying.java
rename to game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
index c5bec5d4a..538b5a8bc 100644
--- a/src/main/java/net/minecraft/core/entity/MobFlying.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.entity;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
@@ -44,7 +45,7 @@ public class MobFlying extends Mob
                 int i = world.getBlockId(MathHelper.floor(x), MathHelper.floor(bb.minY) - 1, MathHelper.floor(z));
                 if(i > 0)
                 {
-                    f2 = Block.blocksList[i].friction * 0.91F;
+                    f2 = Blocks.blocksList[i].friction * 0.91F;
                 }
             }
             float f3 = 0.1627714F / (f2 * f2 * f2);
@@ -56,7 +57,7 @@ public class MobFlying extends Mob
                 int j = world.getBlockId(MathHelper.floor(x), MathHelper.floor(bb.minY) - 1, MathHelper.floor(z));
                 if(j > 0)
                 {
-                    f2 = Block.blocksList[j].friction * 0.91F;
+                    f2 = Blocks.blocksList[j].friction * 0.91F;
                 }
             }
             move(xd, yd, zd);
diff --git a/src/main/java/net/minecraft/core/entity/SkinVariantList.java b/game/core/src/main/java/net/minecraft/core/entity/SkinVariantList.java
similarity index 76%
rename from src/main/java/net/minecraft/core/entity/SkinVariantList.java
rename to game/core/src/main/java/net/minecraft/core/entity/SkinVariantList.java
index 30549e9d5..e385f4ebf 100644
--- a/src/main/java/net/minecraft/core/entity/SkinVariantList.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/SkinVariantList.java
@@ -5,5 +5,5 @@ import org.jetbrains.annotations.Nullable;
 
 public abstract class SkinVariantList {
     public abstract @NotNull String getSkinReference(@Nullable String variantJsonPath, @NotNull String defaultKey, int skinIndex);
-
+    public abstract int nextSkinVariant(@Nullable String variantJsonPath, int skinIndex);
 }
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
similarity index 93%
rename from src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
rename to game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
index cf444dc60..28459fb84 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
@@ -88,9 +88,9 @@ public abstract class MobAnimal extends MobPathfinder
         int y = MathHelper.floor(bb.minY);
         int z = MathHelper.floor(this.z);
         int id = world.getBlockId(x, y - 1, z);
-        if (Block.blocksList[id] != null)
+        if (Blocks.blocksList[id] != null)
         {
-            return Block.blocksList[id].hasTag(BlockTags.PASSIVE_MOBS_SPAWN) && world.getFullBlockLightValue(x, y, z) > 8 && super.canSpawnHere();
+            return Blocks.blocksList[id].hasTag(BlockTags.PASSIVE_MOBS_SPAWN) && world.getFullBlockLightValue(x, y, z) > 8 && super.canSpawnHere();
         }
         return false;
     }
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
similarity index 96%
rename from src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
rename to game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index a86d846ed..fa28fdcc4 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -2,6 +2,7 @@ package net.minecraft.core.entity.animal;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.MobFlying;
@@ -242,7 +243,7 @@ public class MobFireflyCluster extends MobFlying
         if(world.getCurrentWeather() != null && world.getCurrentWeather().doMobsSpawnInDaylight)
             blockLight = blockLight/2;
 
-        return  blockLight <= 4 && (Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.FIREFLIES_CAN_SPAWN)) && world.checkIfAABBIsClear(bb.grow(-2f, 0f, -2f));
+        return  blockLight <= 4 && (Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.FIREFLIES_CAN_SPAWN)) && world.checkIfAABBIsClear(bb.grow(-2f, 0f, -2f));
     }
 
     @Override
@@ -425,6 +426,14 @@ public class MobFireflyCluster extends MobFlying
     public boolean canRide() {
     	return false;
     }
+
+	@Override
+	public boolean cycleVariant() {
+		MobFireflyCluster.FireflyColor color = MobFireflyCluster.FireflyColor.fireFlyColors.get(getColor().getId() + 1 % MobFireflyCluster.FireflyColor.fireFlyColors.size());
+		setColor(color == null ? MobFireflyCluster.FireflyColor.GREEN : color);
+		return true;
+	}
+
 	public static class FireflyColor {
 		public static Map<Integer, FireflyColor> fireFlyColors = new HashMap<>();
 		public static FireflyColor GREEN = register(new FireflyColor(0, "fireflyGreen", new Biome[] {
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
similarity index 94%
rename from src/main/java/net/minecraft/core/entity/animal/MobPig.java
rename to game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index 3f0124453..b1e97986e 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -3,6 +3,7 @@ package net.minecraft.core.entity.animal;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.monster.MobZombiePig;
@@ -139,10 +140,10 @@ public class MobPig extends MobAnimal
     @Override
     public boolean isFavouriteItem(ItemStack itemStack)
     {
-        if(itemStack == null || itemStack.itemID >= Block.blocksList.length)
+        if(itemStack == null || itemStack.itemID >= Blocks.blocksList.length)
             return false;
 
-        return Block.blocksList[itemStack.itemID].hasTag(BlockTags.PIGS_FAVOURITE_BLOCK);
+        return Blocks.blocksList[itemStack.itemID].hasTag(BlockTags.PIGS_FAVOURITE_BLOCK);
     }
     public List<WeightedRandomLootObject> burningMobDrops = new ArrayList<>();
 }
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobSheep.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
similarity index 98%
rename from src/main/java/net/minecraft/core/entity/animal/MobSheep.java
rename to game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
index 78ad081b8..110088d9f 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
@@ -279,10 +279,10 @@ public class MobSheep extends MobAnimal
     @Override
     public boolean isFavouriteItem(ItemStack itemStack)
     {
-        if(itemStack == null || itemStack.itemID >= Block.blocksList.length)
+        if(itemStack == null || itemStack.itemID >= Blocks.blocksList.length)
             return false;
 
-        return Block.blocksList[itemStack.itemID].hasTag(BlockTags.SHEEPS_FAVOURITE_BLOCK);
+        return Blocks.blocksList[itemStack.itemID].hasTag(BlockTags.SHEEPS_FAVOURITE_BLOCK);
     }
 
     public void setGrowthTimer(int growthTimer){
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobSquid.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
similarity index 98%
rename from src/main/java/net/minecraft/core/entity/animal/MobSquid.java
rename to game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
index d7375d80d..c586e6ab7 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
@@ -2,6 +2,7 @@ package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
@@ -206,7 +207,7 @@ public class MobSquid extends MobWaterAnimal
                     for(int _z = minZ; _z <= maxZ; _z++)
                     {
                         int blockId = world.getBlockId(_x, _y, _z);
-                        if(blockId != 0 && Block.blocksList[blockId].blockMaterial != Material.water)
+                        if(blockId != 0 && Blocks.blocksList[blockId].blockMaterial != Material.water)
                         {
                             return true;
                         }
diff --git a/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
similarity index 99%
rename from src/main/java/net/minecraft/core/entity/monster/MobGhast.java
rename to game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index de9506e2d..bfaf359bf 100644
--- a/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -188,6 +188,8 @@ public class MobGhast extends MobFlying
             if(attackCharge > 0)
             {
                 attackCharge--;
+            } else {
+                targetedEntity = null;
             }
         } else
         {
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
similarity index 99%
rename from src/main/java/net/minecraft/core/entity/player/Player.java
rename to game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index d9638f7a9..0b8c2b39e 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -272,6 +272,11 @@ public abstract class Player extends Mob
         craftingInventory = inventorySlots;
     }
 
+    @Override
+    public boolean canInteract() {
+        return getGamemode().canInteract() && isAlive();
+    }
+
     @Override
 	public void rideTick()
     {
diff --git a/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
similarity index 96%
rename from src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
rename to game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
index ccd0b4b41..02853f6af 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
@@ -118,9 +118,8 @@ public class ProjectileArrow extends Projectile
         Block block = world.getBlock(xTile, yTile, zTile);
         if(block != null)
         {
-            block.setBlockBoundsBasedOnState(world, xTile, yTile, zTile);
-            AABB axisalignedbb = block.getCollisionBoundingBoxFromPool(world, xTile, yTile, zTile);
-            if(axisalignedbb != null && axisalignedbb.contains(Vec3.getTempVec3(x, y, z)))
+            AABB aabb = block.getCollisionBoundingBoxFromPool(world, xTile, yTile, zTile);
+            if(aabb != null && aabb.contains(Vec3.getTempVec3(x, y, z)))
             {
                 setGrounded(true);
             }
@@ -156,7 +155,7 @@ public class ProjectileArrow extends Projectile
     public HitResult getHitResult(){
         Vec3 oldPosition = Vec3.getTempVec3(x, y, z);
         Vec3 newPosition = Vec3.getTempVec3(x + xd, y + yd, z + zd);
-        return world.checkBlockCollisionBetweenPoints(oldPosition, newPosition, false, true);
+        return world.checkBlockCollisionBetweenPoints(oldPosition, newPosition, false, true, false);
     }
     public void onHit(HitResult hitResult){
         if(hitResult.entity != null)
diff --git a/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
similarity index 99%
rename from src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
rename to game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
index f4b2abd9a..ffcd35bb6 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
@@ -47,7 +47,7 @@ public class ProjectileCannonballBouncy extends ProjectileCannonball
         // Check for block collision
         Vec3 currentPos = Vec3.getTempVec3(x, y, z);
         Vec3 nextPos = Vec3.getTempVec3(x + xd, y + yd - 0.25f, z + zd);
-        HitResult hit = world.checkBlockCollisionBetweenPoints(currentPos, nextPos, false, true);
+        HitResult hit = world.checkBlockCollisionBetweenPoints(currentPos, nextPos, false, true, false);
         if(hit != null)
         {
             if (hit.hitType == HitResult.HitType.TILE)
diff --git a/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
similarity index 94%
rename from src/main/java/net/minecraft/core/item/ItemDye.java
rename to game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index e132b95b4..cb6c392bf 100644
--- a/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -57,7 +57,7 @@ public class ItemDye extends Item
         if(itemstack.getMetadata() == DyeColor.WHITE.itemMeta)
         {
             int id = world.getBlockId(blockX, blockY, blockZ);
-            Block block = Block.blocksList[id];
+            Block block = Blocks.blocksList[id];
             if (block instanceof IBonemealable){
                if (((IBonemealable) block).onBonemealUsed(itemstack, player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced)){
                    return true;
@@ -67,7 +67,7 @@ public class ItemDye extends Item
             {
                 if(!world.isClientSide)
                 {
-                    if(Block.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
+                    if(Blocks.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
                     	int grass = Blocks.GRASS.id;
                     	if(world.dimensionData.getWorldType() == WorldTypes.OVERWORLD_RETRO) {
                     		grass = Blocks.GRASS_RETRO.id;
@@ -85,7 +85,7 @@ public class ItemDye extends Item
             {
                 if (!world.isClientSide)
                 {
-                    if(Block.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
+                    if(Blocks.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
                         int grass = Blocks.GRASS_SCORCHED.id;
                         world.setBlockWithNotify(blockX, blockY, blockZ, grass);
                         if (player == null || player.getGamemode().consumeBlocks())
@@ -97,7 +97,7 @@ public class ItemDye extends Item
                 return true;
             }
 
-            if(Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.GROWS_FLOWERS))
+            if(Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.GROWS_FLOWERS))
             {
                 if(!world.isClientSide)
                 {
@@ -117,7 +117,7 @@ label0:
                             l1 += ((itemRand.nextInt(3) - 1) * itemRand.nextInt(3)) / 2;
                             i2 += itemRand.nextInt(3) - 1;
                             int id1 = world.getBlockId(k1, l1 - 1, i2);
-                            if(Block.blocksList[id1] == null || !Block.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS))
+                            if(Blocks.blocksList[id1] == null || !Blocks.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS))
                             {
                                 continue label0;
                             }
